pandoc-1.12.2.1: Conversion between markup formats

Portability | portable
Stability | alpha
Maintainer | John MacFarlane <jgm@berkeley.edu>
Safe Haskell | None

Text.Pandoc

Contents

- Definitions
- Generics
- Options
- Lists of readers and writers
- Readers: converting to Pandoc format
- Writers: converting from Pandoc format
- Rendering templates and default templates
- Version
- Miscellaneous

Description

This helper module exports the main writers, readers, and data structure definitions from the Pandoc libraries.

A typical application will chain together a reader and a writer to convert strings from one format to another. For example, the following simple program will act as a filter converting markdown fragments to reStructuredText, using reference-style links instead of inline links:

     module Main where
     import Text.Pandoc

     markdownToRST :: String -> String
     markdownToRST =
       (writeRST def {writerReferenceLinks = True}) . readMarkdown def

     main = getContents >>= putStrLn . markdownToRST

Note: all of the readers assume that the input text has `'\n'` line endings. So if you get your input text from a web form, you should remove `'\r'` characters using `filter (/='\r')`.

Synopsis

- module Text.Pandoc.Definition
- module Text.Pandoc.Generic
- module Text.Pandoc.Options
- readers :: [(String, ReaderOptions -> String -> IO Pandoc)]
- writers :: [(String, Writer)]
- readMarkdown :: ReaderOptions -> String -> Pandoc
- readMediaWiki :: ReaderOptions -> String -> Pandoc
- readRST :: ReaderOptions -> String -> Pandoc
- readLaTeX :: ReaderOptions -> String -> Pandoc
- readHtml :: ReaderOptions -> String -> Pandoc
- readTextile :: ReaderOptions -> String -> Pandoc
- readDocBook :: ReaderOptions -> String -> Pandoc
- readOPML :: ReaderOptions -> String -> Pandoc
- readHaddock :: ReaderOptions -> String -> Pandoc
- readNative :: String -> Pandoc
- readJSON :: ReaderOptions -> String -> Pandoc
- data Writer
  - = PureStringWriter (WriterOptions -> Pandoc -> String)
  - | IOStringWriter (WriterOptions -> Pandoc -> IO String)
  - | IOByteStringWriter (WriterOptions -> Pandoc -> IO ByteString)
- writeNative :: WriterOptions -> Pandoc -> String
- writeJSON :: WriterOptions -> Pandoc -> String
- writeMarkdown :: WriterOptions -> Pandoc -> String
- writePlain :: WriterOptions -> Pandoc -> String
- writeRST :: WriterOptions -> Pandoc -> String
- writeLaTeX :: WriterOptions -> Pandoc -> String
- writeConTeXt :: WriterOptions -> Pandoc -> String
- writeTexinfo :: WriterOptions -> Pandoc -> String
- writeHtml :: WriterOptions -> Pandoc -> Html
- writeHtmlString :: WriterOptions -> Pandoc -> String
- writeDocbook :: WriterOptions -> Pandoc -> String
- writeOPML :: WriterOptions -> Pandoc -> String
- writeOpenDocument :: WriterOptions -> Pandoc -> String
- writeMan :: WriterOptions -> Pandoc -> String
- writeMediaWiki :: WriterOptions -> Pandoc -> String
- writeTextile :: WriterOptions -> Pandoc -> String
- writeRTF :: WriterOptions -> Pandoc -> String
- writeODT :: WriterOptions -> Pandoc -> IO ByteString
- writeDocx :: WriterOptions -> Pandoc -> IO ByteString
- writeEPUB :: WriterOptions -> Pandoc -> IO ByteString
- writeFB2 :: WriterOptions -> Pandoc -> IO String
- writeOrg :: WriterOptions -> Pandoc -> String
- writeAsciiDoc :: WriterOptions -> Pandoc -> String
- writeCustom :: FilePath -> WriterOptions -> Pandoc -> IO String
- module Text.Pandoc.Templates
- pandocVersion :: String
- getReader :: String -> Either String (ReaderOptions -> String -> IO Pandoc)
- getWriter :: String -> Either String Writer
- class ToJSONFilter a => ToJsonFilter a where
  - toJsonFilter :: a -> IO ()

# Definitions

module Text.Pandoc.Definition

# Generics

module Text.Pandoc.Generic

# Options

module Text.Pandoc.Options

# Lists of readers and writers

readers :: [(String, ReaderOptions -> String -> IO Pandoc)]Source

Association list of formats and readers.

writers :: [(String, Writer)]Source

Association list of formats and writers.

# Readers: converting to Pandoc format

readMarkdown Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assuming `'\n'` line endings)
-> Pandoc |

Read markdown from an input string and return a Pandoc document.

readMediaWiki Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assuming `'\n'` line endings)
-> Pandoc |

Read mediawiki from an input string and return a Pandoc document.

readRST Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assuming `'\n'` line endings)
-> Pandoc |

Parse reStructuredText string and return Pandoc document.

readLaTeX Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assumes `'\n'` line endings)
-> Pandoc |

Parse LaTeX from string and return `Pandoc` document.

readHtml Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assumes `'\n'` line endings)
-> Pandoc |

Convert HTML-formatted string to `Pandoc` document.

readTextile Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse (assuming `'\n'` line endings)
-> Pandoc |

Parse a Textile text and return a Pandoc document.

readDocBook :: ReaderOptions -> String -> Pandoc Source

readOPML :: ReaderOptions -> String -> Pandoc Source

readHaddock Source

Arguments

:: ReaderOptions | Reader options
-> String | String to parse
-> Pandoc |

Parse Haddock markup and return a `Pandoc` document.

readNative Source

Arguments

:: String | String to parse (assuming `'\n'` line endings)
-> Pandoc |

Read native formatted text and return a Pandoc document. The input may be a full pandoc document, a block list, a block, an inline list, or an inline. Thus, for example,

     Str "hi"

will be treated as if it were

     Pandoc nullMeta [Plain [Str "hi"]]

readJSON :: ReaderOptions -> String -> Pandoc Source

# Writers: converting from Pandoc format

data Writer Source

Constructors

PureStringWriter (WriterOptions -> Pandoc -> String) |
IOStringWriter (WriterOptions -> Pandoc -> IO String) |
IOByteStringWriter (WriterOptions -> Pandoc -> IO ByteString) |

writeNative :: WriterOptions -> Pandoc -> String Source

Prettyprint Pandoc document.

writeJSON :: WriterOptions -> Pandoc -> String Source

writeMarkdown :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to Markdown.

writePlain :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to plain text (like markdown, but without links, pictures, or inline formatting).

writeRST :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to RST.

writeLaTeX :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to LaTeX.

writeConTeXt :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to ConTeXt.

writeTexinfo :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to Texinfo.

writeHtml :: WriterOptions -> Pandoc -> Html Source

Convert Pandoc document to Html structure.

writeHtmlString :: WriterOptions -> Pandoc -> String Source

Convert Pandoc document to Html string.

writeDocbook :: WriterOptions -> Pandoc -> String Source

Convert Pandoc document to string in Docbook format.

writeOPML :: WriterOptions -> Pandoc -> String Source

Convert Pandoc document to string in OPML format.

writeOpenDocument :: WriterOptions -> Pandoc -> String Source

Convert Pandoc document to string in OpenDocument format.

writeMan :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to Man.

writeMediaWiki :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to MediaWiki.

writeTextile :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to Textile.

writeRTF :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to a string in rich text format.

writeODT Source

Arguments

:: WriterOptions | Writer options
-> Pandoc | Document to convert
-> IO ByteString |

Produce an ODT file from a Pandoc document.

writeDocx Source

Arguments

:: WriterOptions | Writer options
-> Pandoc | Document to convert
-> IO ByteString |

Produce an Docx file from a Pandoc document.

writeEPUB Source

Arguments

:: WriterOptions | Writer options
-> Pandoc | Document to convert
-> IO ByteString |

Produce an EPUB file from a Pandoc document.

writeFB2 Source

Arguments

:: WriterOptions | conversion options
-> Pandoc | document to convert
-> IO String | FictionBook2 document (not encoded yet)

Produce an FB2 document from a `Pandoc` document.

writeOrg :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to Org.

writeAsciiDoc :: WriterOptions -> Pandoc -> String Source

Convert Pandoc to AsciiDoc.

writeCustom :: FilePath -> WriterOptions -> Pandoc -> IO String Source

Convert Pandoc to custom markup.

# Rendering templates and default templates

module Text.Pandoc.Templates

# Version

pandocVersion :: String Source

Version number of pandoc library.

# Miscellaneous

getReader :: String -> Either String (ReaderOptions -> String -> IO Pandoc)Source

Retrieve reader based on formatSpec (format+extensions).

getWriter :: String -> Either String Writer Source

Retrieve writer based on formatSpec (format+extensions).

class ToJSONFilter a => ToJsonFilter a where Source

Deprecated. Use `toJSONFilter` from `Text.Pandoc.JSON` instead.

Methods

toJsonFilter :: a -> IO ()Source

Deprecated: Use `toJSONFilter` from `JSON` instead